{
    "$graph": [
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement",
                    "expressionLib": [
                        "var default_output_filename = function() { if (inputs.output_filename == \"\"){ var root = inputs.intervals_file.basename.split('.').slice(0,-1).join('.'); return (root == \"\")?inputs.intervals_file.basename+\".fa\":root+\".fa\"; } else { return inputs.output_filename; } };"
                    ]
                }
            ],
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "biowardrobe2/bedtools2:v2.26.0"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "secondaryFiles": [
                        ".fai"
                    ],
                    "inputBinding": {
                        "position": 5,
                        "prefix": "-fi"
                    },
                    "doc": "Genome file in FASTA format",
                    "id": "#bedtools-getfasta.cwl/genome_fasta_file"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 6,
                        "prefix": "-bed"
                    },
                    "doc": "Intervals file defined in a BED/GFF/VCF format",
                    "id": "#bedtools-getfasta.cwl/intervals_file"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "",
                    "doc": "Output file name",
                    "id": "#bedtools-getfasta.cwl/output_filename"
                }
            ],
            "baseCommand": [
                "bedtools",
                "getfasta"
            ],
            "stdout": "$(default_output_filename())",
            "doc": "Extracts sequences from a FASTA file for each of the intervals defined in a BED/GFF/VCF file. Only selected parameters are implemented.\n",
            "id": "#bedtools-getfasta.cwl",
            "http://schema.org/mainEntity": {
                "class": "http://schema.org/SoftwareSourceCode",
                "id": "#bedtools-metadata.yaml",
                "http://schema.org/name": "bedtools",
                "http://schema.org/about": "A software suite for the comparison, manipulation and annotation of genomic features in browser extensible data (BED) and general feature format (GFF) format. BEDTools also supports the comparison of sequence alignments in BAM format to both BED and GFF features. The tools are extremely efficient and allow the user to compare large datasets (e.g. next-generation sequencing data) with both public and custom genome annotation tracks. BEDTools can be combined with one another as well as with standard UNIX commands, thus facilitating routine genomics tasks as well as pipelines that can quickly answer intricate questions of large genomic datasets.\n",
                "http://schema.org/url": "http://bedtools.readthedocs.org",
                "http://schema.org/codeRepository": "https://github.com/arq5x/bedtools2",
                "http://schema.org/license": [
                    "https://opensource.org/licenses/GPL-2.0"
                ],
                "http://schema.org/targetProduct": {
                    "class": "http://schema.org/SoftwareApplication",
                    "http://schema.org/softwareVersion": "2.26.0",
                    "http://schema.org/applicationCategory": "command line tool"
                },
                "http://schema.org/programmingLanguage": "C++",
                "http://schema.org/publication": [
                    {
                        "class": "http://schema.org/ScholarlyArticle",
                        "id": "#bedtools-metadata.yaml/10.1093/bioinformatics/btq033",
                        "datePublished": "28 January 2010",
                        "http://schema.org/name": "BEDTools: a flexible suite of utilities for comparing genomic features",
                        "http://schema.org/author": [
                            {
                                "class": "http://schema.org/Person",
                                "http://schema.org/name": "Aaron R. Quinlan"
                            },
                            {
                                "class": "http://schema.org/Person",
                                "http://schema.org/name": "Ira M. Hall"
                            }
                        ],
                        "http://schema.org/url": "https://academic.oup.com/bioinformatics/article-lookup/doi/10.1093/bioinformatics/btq033"
                    }
                ],
                "http://schema.org/discussionUrl": [
                    "https://github.com/arq5x/bedtools2/issues",
                    "https://groups.google.com/forum/#!forum/bedtools-discuss"
                ],
                "http://schema.org/creator": [
                    {
                        "class": "http://schema.org/Organization",
                        "http://schema.org/name": "University of Utah",
                        "http://schema.org/member": [
                            {
                                "class": "http://schema.org/Person",
                                "http://schema.org/name": "Aaron Quinlan",
                                "http://schema.org/description": "Main author"
                            },
                            {
                                "class": "http://schema.org/Person",
                                "http://schema.org/name": "Neil Kindlon",
                                "http://schema.org/description": "Main author"
                            }
                        ]
                    }
                ]
            },
            "http://schema.org/name": "bedtools-getfasta",
            "http://schema.org/downloadUrl": "https://raw.githubusercontent.com/Barski-lab/workflows/master/tools/bedtools-getfasta.cwl",
            "http://schema.org/codeRepository": "https://github.com/Barski-lab/workflows",
            "http://schema.org/license": "http://www.apache.org/licenses/LICENSE-2.0",
            "http://schema.org/isPartOf": {
                "class": "http://schema.org/CreativeWork",
                "http://schema.org/name": "Common Workflow Language",
                "http://schema.org/url": "http://commonwl.org/"
            },
            "http://schema.org/creator": [
                {
                    "class": "http://schema.org/Organization",
                    "http://schema.org/legalName": "Cincinnati Children's Hospital Medical Center",
                    "http://schema.org/location": [
                        {
                            "class": "http://schema.org/PostalAddress",
                            "http://schema.org/addressCountry": "USA",
                            "http://schema.org/addressLocality": "Cincinnati",
                            "http://schema.org/addressRegion": "OH",
                            "http://schema.org/postalCode": "45229",
                            "http://schema.org/streetAddress": "3333 Burnet Ave",
                            "http://schema.org/telephone": "+1(513)636-4200"
                        }
                    ],
                    "http://schema.org/logo": "https://www.cincinnatichildrens.org/-/media/cincinnati%20childrens/global%20shared/childrens-logo-new.png",
                    "http://schema.org/department": [
                        {
                            "class": "http://schema.org/Organization",
                            "http://schema.org/legalName": "Allergy and Immunology",
                            "http://schema.org/department": [
                                {
                                    "class": "http://schema.org/Organization",
                                    "http://schema.org/legalName": "Barski Research Lab",
                                    "http://schema.org/member": [
                                        {
                                            "class": "http://schema.org/Person",
                                            "http://schema.org/name": "Michael Kotliar",
                                            "http://schema.org/email": "mailto:misha.kotliar@gmail.com",
                                            "http://schema.org/sameAs": [
                                                {
                                                    "id": "#0000-0002-6486-3898"
                                                }
                                            ]
                                        }
                                    ]
                                }
                            ]
                        }
                    ]
                }
            ],
            "http://schema.org/about": "Usage:   bedtools getfasta [OPTIONS] -fi <fasta> -bed <bed/gff/vcf>\n\nOptions: \n  -fi\tInput FASTA file\n  -bed\tBED/GFF/VCF file of ranges to extract from -fi\n  -name\tUse the name field for the FASTA header\n  -split\tgiven BED12 fmt., extract and concatenate the sequencesfrom the BED \"blocks\" (e.g., exons)\n  -tab\tWrite output in TAB delimited format.\n    - Default is FASTA format.\n\n  -s\tForce strandedness. If the feature occupies the antisense,\n    strand, the sequence will be reverse complemented.\n    - By default, strand information is ignored.\n\n  -fullHeader\tUse full fasta header.\n    - By default, only the word before the first space or tab is used.",
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(default_output_filename())"
                    },
                    "doc": "Sequences file",
                    "id": "#bedtools-getfasta.cwl/sequences_file"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement",
                    "expressionLib": [
                        "var default_output_filename = function() { if (inputs.output_filename == \"\"){ return inputs.bed_file.basename; } else { return inputs.output_filename; } };"
                    ]
                }
            ],
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "biowardrobe2/bedtools2:v2.26.0"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 5,
                        "prefix": "-i"
                    },
                    "doc": "The input BED file must be sorted by chrom, then start",
                    "id": "#bedtools-merge.cwl/bed_file"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 6,
                        "prefix": "-d"
                    },
                    "doc": "Maximum distance between features to be merged",
                    "id": "#bedtools-merge.cwl/max_distance"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "",
                    "doc": "Output file name",
                    "id": "#bedtools-merge.cwl/output_filename"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(default_output_filename())"
                    },
                    "doc": "Merged BED file",
                    "id": "#bedtools-merge.cwl/merged_bed_file"
                }
            ],
            "baseCommand": [
                "bedtools",
                "merge"
            ],
            "stdout": "$(default_output_filename())",
            "doc": "Merges features from BED file. Only selected parameters are implemented.\n",
            "id": "#bedtools-merge.cwl",
            "http://schema.org/mainEntity": {
                "$import": "#bedtools-metadata.yaml"
            },
            "http://schema.org/name": "bedtools-merge",
            "http://schema.org/downloadUrl": "https://raw.githubusercontent.com/Barski-lab/workflows/master/tools/bedtools-merge.cwl",
            "http://schema.org/codeRepository": "https://github.com/Barski-lab/workflows",
            "http://schema.org/license": "http://www.apache.org/licenses/LICENSE-2.0",
            "http://schema.org/isPartOf": {
                "class": "http://schema.org/CreativeWork",
                "http://schema.org/name": "Common Workflow Language",
                "http://schema.org/url": "http://commonwl.org/"
            },
            "http://schema.org/creator": [
                {
                    "class": "http://schema.org/Organization",
                    "http://schema.org/legalName": "Cincinnati Children's Hospital Medical Center",
                    "http://schema.org/location": [
                        {
                            "class": "http://schema.org/PostalAddress",
                            "http://schema.org/addressCountry": "USA",
                            "http://schema.org/addressLocality": "Cincinnati",
                            "http://schema.org/addressRegion": "OH",
                            "http://schema.org/postalCode": "45229",
                            "http://schema.org/streetAddress": "3333 Burnet Ave",
                            "http://schema.org/telephone": "+1(513)636-4200"
                        }
                    ],
                    "http://schema.org/logo": "https://www.cincinnatichildrens.org/-/media/cincinnati%20childrens/global%20shared/childrens-logo-new.png",
                    "http://schema.org/department": [
                        {
                            "class": "http://schema.org/Organization",
                            "http://schema.org/legalName": "Allergy and Immunology",
                            "http://schema.org/department": [
                                {
                                    "class": "http://schema.org/Organization",
                                    "http://schema.org/legalName": "Barski Research Lab",
                                    "http://schema.org/member": [
                                        {
                                            "class": "http://schema.org/Person",
                                            "http://schema.org/name": "Michael Kotliar",
                                            "http://schema.org/email": "mailto:misha.kotliar@gmail.com",
                                            "http://schema.org/sameAs": [
                                                {
                                                    "$import": "#0000-0002-6486-3898"
                                                }
                                            ]
                                        }
                                    ]
                                }
                            ]
                        }
                    ]
                }
            ],
            "http://schema.org/about": "Usage:   bedtools merge [OPTIONS] -i <bed/gff/vcf>\n\nOptions: \n  -s\tForce strandedness.  That is, only merge features\n    that are on the same strand.\n    - By default, merging is done without respect to strand.\n\n  -S\tForce merge for one specific strand only.\n    Follow with + or - to force merge from only\n    the forward or reverse strand, respectively.\n    - By default, merging is done without respect to strand.\n\n  -d\tMaximum distance between features allowed for features\n    to be merged.\n    - Def. 0. That is, overlapping & book-ended features are merged.\n    - (INTEGER)\n    - Note: negative values enforce the number of b.p. required for overlap.\n\n  -c\tSpecify columns from the B file to map onto intervals in A.\n    Default: 5.\n    Multiple columns can be specified in a comma-delimited list.\n\n  -o\tSpecify the operation that should be applied to -c.\n    Valid operations:\n        sum, min, max, absmin, absmax,\n        mean, median, mode, antimode\n        stdev, sstdev\n        collapse (i.e., print a delimited list (duplicates allowed)), \n        distinct (i.e., print a delimited list (NO duplicates allowed)), \n        distinct_sort_num (as distinct, sorted numerically, ascending),\n        distinct_sort_num_desc (as distinct, sorted numerically, desscending),\n        distinct_only (delimited list of only unique values),\n        count\n        count_distinct (i.e., a count of the unique values in the column), \n        first (i.e., just the first value in the column), \n        last (i.e., just the last value in the column), \n    Default: sum\n    Multiple operations can be specified in a comma-delimited list.\n\n    If there is only column, but multiple operations, all operations will be\n    applied on that column. Likewise, if there is only one operation, but\n    multiple columns, that operation will be applied to all columns.\n    Otherwise, the number of columns must match the the number of operations,\n    and will be applied in respective order.\n    E.g., \"-c 5,4,6 -o sum,mean,count\" will give the sum of column 5,\n    the mean of column 4, and the count of column 6.\n    The order of output columns will match the ordering given in the command.\n\n\n  -delim\tSpecify a custom delimiter for the collapse operations.\n    - Example: -delim \"|\"\n    - Default: \",\".\n\n  -prec\tSets the decimal precision for output (Default: 5)\n\n  -bed\tIf using BAM input, write output as BED.\n\n  -header\tPrint the header from the A file prior to results.\n\n  -nobuf\tDisable buffered output. Using this option will cause each line\n    of output to be printed as it is generated, rather than saved\n    in a buffer. This will make printing large output files \n    noticeably slower, but can be useful in conjunction with\n    other software tools and scripts that need to process one\n    line of bedtools output at a time.\n\n  -iobuf\tSpecify amount of memory to use for input buffer.\n    Takes an integer argument. Optional suffixes K/M/G supported.\n    Note: currently has no effect with compressed files.\n\nNotes: \n  (1) The input file (-i) file must be sorted by chrom, then start.\n"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement",
                    "expressionLib": [
                        "var default_output_filename = function() { if (inputs.output_filename == \"\"){ return inputs.bed_file.basename; } else { return inputs.output_filename; } };"
                    ]
                }
            ],
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "biowardrobe2/bedtools2:v2.26.0"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 5,
                        "prefix": "-i"
                    },
                    "doc": "The input BED file with features to be shuffled\n",
                    "id": "#bedtools-shuffle.cwl/bed_file"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 6,
                        "prefix": "-g"
                    },
                    "doc": "Input genome file with chromosome lengths\n",
                    "id": "#bedtools-shuffle.cwl/chrom_length_file"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 7,
                        "prefix": "-excl"
                    },
                    "doc": "The BED file with regions where you do not want the permuted features to be placed\n",
                    "id": "#bedtools-shuffle.cwl/excl_bed_file"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "inputBinding": {
                        "position": 8,
                        "prefix": "-incl"
                    },
                    "doc": "The BED file with regions where you want the permuted features to be placed\n",
                    "id": "#bedtools-shuffle.cwl/incl_bed_file"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 11,
                        "prefix": "-maxTries"
                    },
                    "doc": "Maximum number of attempts to find a home for a shuffled interval. Default: 1000\n",
                    "id": "#bedtools-shuffle.cwl/max_tries"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 10,
                        "prefix": "-noOverlapping"
                    },
                    "doc": "Don't allow shuffled intervals to overlap\n",
                    "id": "#bedtools-shuffle.cwl/no_overlapping"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "",
                    "doc": "Output file name\n",
                    "id": "#bedtools-shuffle.cwl/output_filename"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 9,
                        "prefix": "-seed"
                    },
                    "doc": "Seed for pseudo-random number generation. Default: random\n",
                    "id": "#bedtools-shuffle.cwl/seed"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(default_output_filename())"
                    },
                    "doc": "Shuffled BED file\n",
                    "id": "#bedtools-shuffle.cwl/shuffled_bed_file"
                }
            ],
            "baseCommand": [
                "bedtools",
                "shuffle"
            ],
            "stdout": "$(default_output_filename())",
            "doc": "Randomly permutes the genomic locations of a feature file among a genome defined in a genome file.\nOne can also provide an \u201cexclusions\u201d BED file that lists regions where you do not want the permuted\nfeatures to be placed. Or instead \u201cinclusions\u201d BED fils that defines coordinates in which features\nin -i should be randomly placed. To make experiment reproducible, set \"seed\" option.\nNOTE: limited parameters are impelented.\n",
            "id": "#bedtools-shuffle.cwl",
            "http://schema.org/mainEntity": {
                "$import": "#bedtools-metadata.yaml"
            },
            "http://schema.org/name": "bedtools-shuffle",
            "http://schema.org/downloadUrl": "https://raw.githubusercontent.com/Barski-lab/workflows/master/tools/bedtools-shuffle.cwl",
            "http://schema.org/codeRepository": "https://github.com/Barski-lab/workflows",
            "http://schema.org/license": "http://www.apache.org/licenses/LICENSE-2.0",
            "http://schema.org/isPartOf": {
                "class": "http://schema.org/CreativeWork",
                "http://schema.org/name": "Common Workflow Language",
                "http://schema.org/url": "http://commonwl.org/"
            },
            "http://schema.org/creator": [
                {
                    "class": "http://schema.org/Organization",
                    "http://schema.org/legalName": "Cincinnati Children's Hospital Medical Center",
                    "http://schema.org/location": [
                        {
                            "class": "http://schema.org/PostalAddress",
                            "http://schema.org/addressCountry": "USA",
                            "http://schema.org/addressLocality": "Cincinnati",
                            "http://schema.org/addressRegion": "OH",
                            "http://schema.org/postalCode": "45229",
                            "http://schema.org/streetAddress": "3333 Burnet Ave",
                            "http://schema.org/telephone": "+1(513)636-4200"
                        }
                    ],
                    "http://schema.org/logo": "https://www.cincinnatichildrens.org/-/media/cincinnati%20childrens/global%20shared/childrens-logo-new.png",
                    "http://schema.org/department": [
                        {
                            "class": "http://schema.org/Organization",
                            "http://schema.org/legalName": "Allergy and Immunology",
                            "http://schema.org/department": [
                                {
                                    "class": "http://schema.org/Organization",
                                    "http://schema.org/legalName": "Barski Research Lab",
                                    "http://schema.org/member": [
                                        {
                                            "class": "http://schema.org/Person",
                                            "http://schema.org/name": "Michael Kotliar",
                                            "http://schema.org/email": "mailto:misha.kotliar@gmail.com",
                                            "http://schema.org/sameAs": [
                                                {
                                                    "$import": "#0000-0002-6486-3898"
                                                }
                                            ]
                                        }
                                    ]
                                }
                            ]
                        }
                    ]
                }
            ],
            "http://schema.org/about": "Usage:   bedtools shuffle [OPTIONS] -i <bed/gff/vcf> -g <genome>\n\nOptions: \n  -excl\tA BED/GFF/VCF file of coordinates in which features in -i\n    should not be placed (e.g. gaps.bed).\n\n  -incl\tInstead of randomly placing features in a genome, the -incl\n    options defines a BED/GFF/VCF file of coordinates in which \n    features in -i should be randomly placed (e.g. genes.bed). \n    Larger -incl intervals will contain more shuffled regions. \n    This method DISABLES -chromFirst. \n  -chrom\tKeep features in -i on the same chromosome.\n    - By default, the chrom and position are randomly chosen.\n    - NOTE: Forces use of -chromFirst (see below).\n\n  -seed\tSupply an integer seed for the shuffling.\n    - By default, the seed is chosen automatically.\n    - (INTEGER)\n\n  -f\tMaximum overlap (as a fraction of the -i feature) with an -excl\n    feature that is tolerated before searching for a new, \n    randomized locus. For example, -f 0.10 allows up to 10%\n    of a randomized feature to overlap with a given feature\n    in the -excl file. **Cannot be used with -incl file.**\n    - Default is 1E-9 (i.e., 1bp).\n    - FLOAT (e.g. 0.50)\n\n  -chromFirst\t\n    Instead of choosing a position randomly among the entire\n    genome (the default), first choose a chrom randomly, and then\n    choose a random start coordinate on that chrom.  This leads\n    to features being ~uniformly distributed among the chroms,\n    as opposed to features being distribute as a function of chrom size.\n\n  -bedpe\tIndicate that the A file is in BEDPE format.\n\n  -maxTries\t\n    Max. number of attempts to find a home for a shuffled interval\n    in the presence of -incl or -excl.\n    Default = 1000.\n  -noOverlapping\t\n    Don't allow shuffled intervals to overlap.\n  -allowBeyondChromEnd\t\n    Allow shuffled intervals to be relocated to a position\n    in which the entire original interval cannot fit w/o exceeding\n    the end of the chromosome.  In this case, the end coordinate of the\n    shuffled interval will be set to the chromosome's length.\n    By default, an interval's original length must be fully-contained\n    within the chromosome."
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement",
                    "expressionLib": [
                        "var default_output_filename = function() { if (inputs.output_filename == \"\"){ return inputs.bed_file.basename; } else { return inputs.output_filename; } };"
                    ]
                }
            ],
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "biowardrobe2/bedtools2:v2.26.0"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 5,
                        "prefix": "-i"
                    },
                    "doc": "The input BED file\n",
                    "id": "#bedtools-slop.cwl/bed_file"
                },
                {
                    "type": [
                        "null",
                        "int",
                        "float"
                    ],
                    "inputBinding": {
                        "position": 7,
                        "prefix": "-b"
                    },
                    "doc": "Increase the BED entry by the same number base pairs\nor a fraction of the feature's length in each direction\n",
                    "id": "#bedtools-slop.cwl/bi_direction"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 6,
                        "prefix": "-g"
                    },
                    "doc": "Input genome file with chromosome lengths\n",
                    "id": "#bedtools-slop.cwl/chrom_length_file"
                },
                {
                    "type": [
                        "null",
                        "int",
                        "float"
                    ],
                    "inputBinding": {
                        "position": 8,
                        "prefix": "-l"
                    },
                    "doc": "The number of base pairs or a fraction of the feature's length\nto subtract from the start coordinate\n",
                    "id": "#bedtools-slop.cwl/left_direction"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "",
                    "doc": "Output file name",
                    "id": "#bedtools-slop.cwl/output_filename"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 11,
                        "prefix": "-pct"
                    },
                    "doc": "Define -l, -b and -r as a fraction of the feature's length\n",
                    "id": "#bedtools-slop.cwl/percent_based"
                },
                {
                    "type": [
                        "null",
                        "int",
                        "float"
                    ],
                    "inputBinding": {
                        "position": 9,
                        "prefix": "-r"
                    },
                    "doc": "The number of base pairs or a fraction of the feature's length\nto add to the end coordinate\n",
                    "id": "#bedtools-slop.cwl/right_direction"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 12,
                        "prefix": "-header"
                    },
                    "doc": "Print the header from the input file prior to results\n",
                    "id": "#bedtools-slop.cwl/save_header"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 10,
                        "prefix": "-s"
                    },
                    "doc": "Define -l and -r based on strand\nE.g. if used, -l 500 for a negative-stranded feature, \nit will add 500 bp downstream\n",
                    "id": "#bedtools-slop.cwl/strand_based"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(default_output_filename())"
                    },
                    "doc": "Extended BED file",
                    "id": "#bedtools-slop.cwl/extended_bed_file"
                }
            ],
            "baseCommand": [
                "bedtools",
                "slop"
            ],
            "stdout": "$(default_output_filename())",
            "doc": "Increases the size of each feature in a feature file by a user-defined number of bases.\nIf not using -b, then -l and -r should be used together\n",
            "id": "#bedtools-slop.cwl",
            "http://schema.org/mainEntity": {
                "$import": "#bedtools-metadata.yaml"
            },
            "http://schema.org/name": "bedtools-slop",
            "http://schema.org/downloadUrl": "https://raw.githubusercontent.com/Barski-lab/workflows/master/tools/bedtools-slop.cwl",
            "http://schema.org/codeRepository": "https://github.com/Barski-lab/workflows",
            "http://schema.org/license": "http://www.apache.org/licenses/LICENSE-2.0",
            "http://schema.org/isPartOf": {
                "class": "http://schema.org/CreativeWork",
                "http://schema.org/name": "Common Workflow Language",
                "http://schema.org/url": "http://commonwl.org/"
            },
            "http://schema.org/creator": [
                {
                    "class": "http://schema.org/Organization",
                    "http://schema.org/legalName": "Cincinnati Children's Hospital Medical Center",
                    "http://schema.org/location": [
                        {
                            "class": "http://schema.org/PostalAddress",
                            "http://schema.org/addressCountry": "USA",
                            "http://schema.org/addressLocality": "Cincinnati",
                            "http://schema.org/addressRegion": "OH",
                            "http://schema.org/postalCode": "45229",
                            "http://schema.org/streetAddress": "3333 Burnet Ave",
                            "http://schema.org/telephone": "+1(513)636-4200"
                        }
                    ],
                    "http://schema.org/logo": "https://www.cincinnatichildrens.org/-/media/cincinnati%20childrens/global%20shared/childrens-logo-new.png",
                    "http://schema.org/department": [
                        {
                            "class": "http://schema.org/Organization",
                            "http://schema.org/legalName": "Allergy and Immunology",
                            "http://schema.org/department": [
                                {
                                    "class": "http://schema.org/Organization",
                                    "http://schema.org/legalName": "Barski Research Lab",
                                    "http://schema.org/member": [
                                        {
                                            "class": "http://schema.org/Person",
                                            "http://schema.org/name": "Michael Kotliar",
                                            "http://schema.org/email": "mailto:misha.kotliar@gmail.com",
                                            "http://schema.org/sameAs": [
                                                {
                                                    "$import": "#0000-0002-6486-3898"
                                                }
                                            ]
                                        }
                                    ]
                                }
                            ]
                        }
                    ]
                }
            ],
            "http://schema.org/about": "Usage:   bedtools slop [OPTIONS] -i <bed/gff/vcf> -g <genome> [-b <int> or (-l and -r)]\n\nOptions: \n  -b\tIncrease the BED/GFF/VCF entry -b base pairs in each direction.\n    - (Integer) or (Float, e.g. 0.1) if used with -pct.\n\n  -l\tThe number of base pairs to subtract from the start coordinate.\n    - (Integer) or (Float, e.g. 0.1) if used with -pct.\n\n  -r\tThe number of base pairs to add to the end coordinate.\n    - (Integer) or (Float, e.g. 0.1) if used with -pct.\n\n  -s\tDefine -l and -r based on strand.\n    E.g. if used, -l 500 for a negative-stranded feature, \n    it will add 500 bp downstream.  Default = false.\n\n  -pct\tDefine -l and -r as a fraction of the feature's length.\n    E.g. if used on a 1000bp feature, -l 0.50, \n    will add 500 bp \"upstream\".  Default = false.\n\n  -header\tPrint the header from the input file prior to results."
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement",
                    "expressionLib": [
                        "var default_output_filename = function() { if (inputs.output_filename == \"\"){ return inputs.reduced_bed_file.basename; } else { return inputs.output_filename; } };"
                    ]
                }
            ],
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "biowardrobe2/bedtools2:v2.26.0"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "",
                    "doc": "Output file name\n",
                    "id": "#bedtools-subtract.cwl/output_filename"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 5,
                        "prefix": "-a"
                    },
                    "doc": "The input BED file from which the features will be substructed\n",
                    "id": "#bedtools-subtract.cwl/reduced_bed_file"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 6,
                        "prefix": "-b"
                    },
                    "doc": "The input BED file that includes the features to be subtracted from -a\n",
                    "id": "#bedtools-subtract.cwl/subtracted_bed_file"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(default_output_filename())"
                    },
                    "doc": "Difference BED file\n",
                    "id": "#bedtools-subtract.cwl/difference_bed_file"
                }
            ],
            "baseCommand": [
                "bedtools",
                "subtract"
            ],
            "stdout": "$(default_output_filename())",
            "doc": "Searches for features in B that overlap A by at least 1 base pair.\nIf an overlapping feature is found in B, the overlapping portion is removed from A\nand the remaining portion of A is reported. If a feature in B overlaps all of\na feature in A, the A feature will not be reported.\nAll parameters except -a and -b used by default.\n",
            "id": "#bedtools-subtract.cwl",
            "http://schema.org/mainEntity": {
                "$import": "#bedtools-metadata.yaml"
            },
            "http://schema.org/name": "bedtools-subtract",
            "http://schema.org/downloadUrl": "https://raw.githubusercontent.com/Barski-lab/workflows/master/tools/bedtools-subtract.cwl",
            "http://schema.org/codeRepository": "https://github.com/Barski-lab/workflows",
            "http://schema.org/license": "http://www.apache.org/licenses/LICENSE-2.0",
            "http://schema.org/isPartOf": {
                "class": "http://schema.org/CreativeWork",
                "http://schema.org/name": "Common Workflow Language",
                "http://schema.org/url": "http://commonwl.org/"
            },
            "http://schema.org/creator": [
                {
                    "class": "http://schema.org/Organization",
                    "http://schema.org/legalName": "Cincinnati Children's Hospital Medical Center",
                    "http://schema.org/location": [
                        {
                            "class": "http://schema.org/PostalAddress",
                            "http://schema.org/addressCountry": "USA",
                            "http://schema.org/addressLocality": "Cincinnati",
                            "http://schema.org/addressRegion": "OH",
                            "http://schema.org/postalCode": "45229",
                            "http://schema.org/streetAddress": "3333 Burnet Ave",
                            "http://schema.org/telephone": "+1(513)636-4200"
                        }
                    ],
                    "http://schema.org/logo": "https://www.cincinnatichildrens.org/-/media/cincinnati%20childrens/global%20shared/childrens-logo-new.png",
                    "http://schema.org/department": [
                        {
                            "class": "http://schema.org/Organization",
                            "http://schema.org/legalName": "Allergy and Immunology",
                            "http://schema.org/department": [
                                {
                                    "class": "http://schema.org/Organization",
                                    "http://schema.org/legalName": "Barski Research Lab",
                                    "http://schema.org/member": [
                                        {
                                            "class": "http://schema.org/Person",
                                            "http://schema.org/name": "Michael Kotliar",
                                            "http://schema.org/email": "mailto:misha.kotliar@gmail.com",
                                            "http://schema.org/sameAs": [
                                                {
                                                    "$import": "#0000-0002-6486-3898"
                                                }
                                            ]
                                        }
                                    ]
                                }
                            ]
                        }
                    ]
                }
            ],
            "http://schema.org/about": "Usage:   bedtools subtract [OPTIONS] -a <bed/gff/vcf> -b <bed/gff/vcf>\n\nOptions: \n  -A\tRemove entire feature if any overlap.  That is, by default,\n    only subtract the portion of A that overlaps B. Here, if\n    any overlap is found (or -f amount), the entire feature is removed.\n\n  -N\tSame as -A except when used with -f, the amount is the sum\n    of all features (not any single feature).\n\n  -wb\tWrite the original entry in B for each overlap.\n    - Useful for knowing _what_ A overlaps. Restricted by -f and -r.\n\n  -wo\tWrite the original A and B entries plus the number of base\n    pairs of overlap between the two features.\n    - Overlaps restricted by -f and -r.\n      Only A features with overlap are reported.\n\n  -s\tRequire same strandedness.  That is, only report hits in B\n    that overlap A on the _same_ strand.\n    - By default, overlaps are reported without respect to strand.\n\n  -S\tRequire different strandedness.  That is, only report hits in B\n    that overlap A on the _opposite_ strand.\n    - By default, overlaps are reported without respect to strand.\n\n  -f\tMinimum overlap required as a fraction of A.\n    - Default is 1E-9 (i.e., 1bp).\n    - FLOAT (e.g. 0.50)\n\n  -F\tMinimum overlap required as a fraction of B.\n    - Default is 1E-9 (i.e., 1bp).\n    - FLOAT (e.g. 0.50)\n\n  -r\tRequire that the fraction overlap be reciprocal for A AND B.\n    - In other words, if -f is 0.90 and -r is used, this requires\n      that B overlap 90% of A and A _also_ overlaps 90% of B.\n\n  -e\tRequire that the minimum fraction be satisfied for A OR B.\n    - In other words, if -e is used with -f 0.90 and -F 0.10 this requires\n      that either 90% of A is covered OR 10% of  B is covered.\n      Without -e, both fractions would have to be satisfied.\n\n  -split\tTreat \"split\" BAM or BED12 entries as distinct BED intervals.\n\n  -g\tProvide a genome file to enforce consistent chromosome sort order\n    across input files. Only applies when used with -sorted option.\n\n  -nonamecheck\tFor sorted data, don't throw an error if the file has different naming conventions\n      for the same chromosome. ex. \"chr1\" vs \"chr01\".\n\n  -sorted\tUse the \"chromsweep\" algorithm for sorted (-k1,1 -k2,2n) input.\n\n  -bed\tIf using BAM input, write output as BED.\n\n  -header\tPrint the header from the A file prior to results.\n\n  -nobuf\tDisable buffered output. Using this option will cause each line\n    of output to be printed as it is generated, rather than saved\n    in a buffer. This will make printing large output files \n    noticeably slower, but can be useful in conjunction with\n    other software tools and scripts that need to process one\n    line of bedtools output at a time.\n\n  -iobuf\tSpecify amount of memory to use for input buffer.\n    Takes an integer argument. Optional suffixes K/M/G supported.\n    Note: currently has no effect with compressed files."
        },
        {
            "class": "CommandLineTool",
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "biowardrobe2/scidap:v0.0.3"
                }
            ],
            "inputs": [
                {
                    "type": [
                        "File",
                        {
                            "type": "array",
                            "items": "File"
                        }
                    ],
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#custom-bash.cwl/input_file"
                },
                {
                    "type": [
                        "null",
                        "string",
                        {
                            "type": "array",
                            "items": "string"
                        }
                    ],
                    "inputBinding": {
                        "position": 3
                    },
                    "id": "#custom-bash.cwl/param"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "cat \"$0\" | grep \"$1\" | sed \"s/$1//g\"  > `basename $0`\n",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#custom-bash.cwl/script"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*"
                    },
                    "id": "#custom-bash.cwl/output_file"
                }
            ],
            "baseCommand": [
                "bash",
                "-c"
            ],
            "doc": "Tool to run custom script set as `script` input with arguments from `param`.\nDefault script runs sed command over the input file and exports results to the file with the same name as input's basename\n",
            "id": "#custom-bash.cwl",
            "http://schema.org/name": "custom-bash",
            "http://schema.org/downloadUrl": "https://raw.githubusercontent.com/Barski-lab/workflows/master/tools/custom-bash.cwl",
            "http://schema.org/codeRepository": "https://github.com/Barski-lab/workflows",
            "http://schema.org/license": "http://www.apache.org/licenses/LICENSE-2.0",
            "http://schema.org/isPartOf": {
                "class": "http://schema.org/CreativeWork",
                "http://schema.org/name": "Common Workflow Language",
                "http://schema.org/url": "http://commonwl.org/"
            },
            "http://schema.org/creator": [
                {
                    "class": "http://schema.org/Organization",
                    "http://schema.org/legalName": "Cincinnati Children's Hospital Medical Center",
                    "http://schema.org/location": [
                        {
                            "class": "http://schema.org/PostalAddress",
                            "http://schema.org/addressCountry": "USA",
                            "http://schema.org/addressLocality": "Cincinnati",
                            "http://schema.org/addressRegion": "OH",
                            "http://schema.org/postalCode": "45229",
                            "http://schema.org/streetAddress": "3333 Burnet Ave",
                            "http://schema.org/telephone": "+1(513)636-4200"
                        }
                    ],
                    "http://schema.org/logo": "https://www.cincinnatichildrens.org/-/media/cincinnati%20childrens/global%20shared/childrens-logo-new.png",
                    "http://schema.org/department": [
                        {
                            "class": "http://schema.org/Organization",
                            "http://schema.org/legalName": "Allergy and Immunology",
                            "http://schema.org/department": [
                                {
                                    "class": "http://schema.org/Organization",
                                    "http://schema.org/legalName": "Barski Research Lab",
                                    "http://schema.org/member": [
                                        {
                                            "class": "http://schema.org/Person",
                                            "http://schema.org/name": "Michael Kotliar",
                                            "http://schema.org/email": "mailto:michael.kotliar@cchmc.org",
                                            "http://schema.org/sameAs": [
                                                {
                                                    "$import": "#0000-0002-6486-3898"
                                                }
                                            ]
                                        }
                                    ]
                                }
                            ]
                        }
                    ]
                }
            ],
            "http://schema.org/about": "Custom bash script runner"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement",
                    "expressionLib": [
                        "var get_output_filename = function() { if (inputs.output_filename == \"\"){ var ext = \".tar.gz\"; var root = inputs.target_fasta_file.basename.split('.').slice(0,-1).join('.'); return (root == \"\")?inputs.target_fasta_file.basename+ext:root+ext; } else { return inputs.output_filename; } };"
                    ]
                }
            ],
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "biowardrobe2/homer:v0.0.2"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 8,
                        "prefix": "-fasta"
                    },
                    "doc": "Background FASTA file suitable for use as a null distribution\n",
                    "id": "#homer-find-motifs.cwl/background_fasta_file"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "enum",
                            "name": "#homer-find-motifs.cwl/motifs_db/motifs",
                            "symbols": [
                                "#homer-find-motifs.cwl/motifs_db/motifs/vertebrates",
                                "#homer-find-motifs.cwl/motifs_db/motifs/insects",
                                "#homer-find-motifs.cwl/motifs_db/motifs/worms",
                                "#homer-find-motifs.cwl/motifs_db/motifs/plants",
                                "#homer-find-motifs.cwl/motifs_db/motifs/yeast",
                                "#homer-find-motifs.cwl/motifs_db/motifs/all"
                            ]
                        }
                    ],
                    "default": "vertebrates",
                    "inputBinding": {
                        "position": 12,
                        "prefix": "-mset"
                    },
                    "doc": "Set motifs DB to check against. Default: vertebrates\n",
                    "id": "#homer-find-motifs.cwl/motifs_db"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 7,
                        "valueFrom": "$(get_output_filename())"
                    },
                    "default": "",
                    "doc": "Name for compressed output folder to keep all the results\n",
                    "id": "#homer-find-motifs.cwl/output_filename"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "#!/bin/bash\necho findMotifs.pl $0 dummy homer_results ${@:2}\nfindMotifs.pl $0 dummy homer_results ${@:2}\necho tar -czf $1 homer_results\ntar -czf $1 homer_results\n",
                    "inputBinding": {
                        "position": 5
                    },
                    "doc": "Bash script to run findMotifs.pl and to compress results to tar.gz\n",
                    "id": "#homer-find-motifs.cwl/script"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 9,
                        "prefix": "-nomotif"
                    },
                    "doc": "Don't search for de novo motif enrichment\n",
                    "id": "#homer-find-motifs.cwl/skip_denovo"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 10,
                        "prefix": "-noknown"
                    },
                    "doc": "Don't search for known motif enrichment\n",
                    "id": "#homer-find-motifs.cwl/skip_known"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 6
                    },
                    "doc": "Target FASTA file to scan for motifs\n",
                    "id": "#homer-find-motifs.cwl/target_fasta_file"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "inputBinding": {
                        "position": 13,
                        "prefix": "-p"
                    },
                    "doc": "Number of threads to use\n",
                    "id": "#homer-find-motifs.cwl/threads"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "position": 11,
                        "prefix": "-b"
                    },
                    "doc": "Use binomial distribution to calculate p-values (default is hypergeometric)\n",
                    "id": "#homer-find-motifs.cwl/use_binomial"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(get_output_filename())"
                    },
                    "doc": "Compressed folder with all generated results\n",
                    "id": "#homer-find-motifs.cwl/compressed_results_folder"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "homer_results/homerResults.html"
                    },
                    "doc": "de novo motifs html file\n",
                    "id": "#homer-find-motifs.cwl/denovo_motifs"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "outputBinding": {
                        "glob": "homer_results/knownResults.html"
                    },
                    "doc": "Known motifs html file\n",
                    "id": "#homer-find-motifs.cwl/known_motifs"
                },
                {
                    "type": "File",
                    "id": "#homer-find-motifs.cwl/stderr_log",
                    "outputBinding": {
                        "glob": "homer_find_motifs_stderr.log"
                    }
                },
                {
                    "type": "File",
                    "id": "#homer-find-motifs.cwl/stdout_log",
                    "outputBinding": {
                        "glob": "homer_find_motifs_stdout.log"
                    }
                }
            ],
            "baseCommand": [
                "bash",
                "-c"
            ],
            "stdout": "homer_find_motifs_stdout.log",
            "stderr": "homer_find_motifs_stderr.log",
            "doc": "HOMER contains a novel motif discovery algorithm that was designed for regulatory element analysis\nin genomics applications (DNA only, no protein).  It is a differential motif discovery algorithm,\nwhich means that it takes two sets of sequences and tries to identify the regulatory elements that\nare specifically enriched in on set relative to the other.  It uses ZOOPS scoring (zero or one\noccurrence per sequence) coupled with the hypergeometric enrichment calculations (or binomial) to\ndetermine motif enrichment.  HOMER also tries its best to account for sequenced bias in the dataset.\nIt was designed with ChIP-Seq and promoter analysis in mind, but can be applied to pretty much any\nnucleic acids motif finding problem.\n\nOnly selected parameters are implemented.\n",
            "id": "#homer-find-motifs.cwl",
            "http://schema.org/mainEntity": {
                "class": "http://schema.org/SoftwareSourceCode",
                "id": "#homer-metadata.yaml",
                "http://schema.org/name": "Homer",
                "http://schema.org/about": "HOMER (Hypergeometric Optimization of Motif EnRichment)"
            },
            "http://schema.org/name": "homer-find-motifs",
            "http://schema.org/downloadUrl": "https://raw.githubusercontent.com/Barski-lab/workflows/master/tools/homer-find-motifs.cwl",
            "http://schema.org/codeRepository": "https://github.com/Barski-lab/workflows",
            "http://schema.org/license": "http://www.apache.org/licenses/LICENSE-2.0",
            "http://schema.org/isPartOf": {
                "class": "http://schema.org/CreativeWork",
                "http://schema.org/name": "Common Workflow Language",
                "http://schema.org/url": "http://commonwl.org/"
            },
            "http://schema.org/creator": [
                {
                    "class": "http://schema.org/Organization",
                    "http://schema.org/legalName": "Cincinnati Children's Hospital Medical Center",
                    "http://schema.org/location": [
                        {
                            "class": "http://schema.org/PostalAddress",
                            "http://schema.org/addressCountry": "USA",
                            "http://schema.org/addressLocality": "Cincinnati",
                            "http://schema.org/addressRegion": "OH",
                            "http://schema.org/postalCode": "45229",
                            "http://schema.org/streetAddress": "3333 Burnet Ave",
                            "http://schema.org/telephone": "+1(513)636-4200"
                        }
                    ],
                    "http://schema.org/logo": "https://www.cincinnatichildrens.org/-/media/cincinnati%20childrens/global%20shared/childrens-logo-new.png",
                    "http://schema.org/department": [
                        {
                            "class": "http://schema.org/Organization",
                            "http://schema.org/legalName": "Allergy and Immunology",
                            "http://schema.org/department": [
                                {
                                    "class": "http://schema.org/Organization",
                                    "http://schema.org/legalName": "Barski Research Lab",
                                    "http://schema.org/member": [
                                        {
                                            "class": "http://schema.org/Person",
                                            "http://schema.org/name": "Michael Kotliar",
                                            "http://schema.org/email": "mailto:misha.kotliar@gmail.com",
                                            "http://schema.org/sameAs": [
                                                {
                                                    "$import": "#0000-0002-6486-3898"
                                                }
                                            ]
                                        }
                                    ]
                                }
                            ]
                        }
                    ]
                }
            ],
            "http://schema.org/about": "Usage:  findMotifs.pl <input list> <promoter set> <output directory> [additoinal options]\n\nexample: findMotifs.pl genelist.txt mouse motifResults/ -len 10\n\nFASTA example: findMotifs.pl targets.fa fasta motifResults/ -fasta background.fa\n\nAvailable Promoter Sets: Add custom promoters sets with loadPromoters.pl\n\nTry typing \"perl /opt/homer/.//configureHomer.pl -list\" to see available promoter sets\nTyping \"perl /opt/homer/.//configureHomer.pl -install NNN\" to install promoter set NNN\n\nBasic options:\n-len <#>[,<#>,<#>...] (motif length, default=8,10,12) [NOTE: values greater 12 may cause the program\n  to run out of memmory - in these cases decrease the number of sequences analyzed]\n-bg <background file> (ids to use as background, default: all genes)\n-start <#> (offset from TSS, default=-300) [max=based on Promoter Set]\n-end <#> (offset from TSS, default=50) [max=based on Promoter Set]\n-rna (output RNA motif logos and compare to RNA motif database, automatically sets -norevopp)\n-mask/-nomask (use/don't use repeatmasked files, default: -mask)\n-S <#> (Number of motifs to optimize, default: 25)\n-mis <#> (global optimization: searches for strings with # mismatches, default: 1)\n-noconvert (will not worry about converting input files into unigene ids)\n-norevopp (do not search the reverse strand for motifs)\n-nomotif (don't search for de novo motif enrichment)\n\nScanning sequence for motifs\n-find <motif file> (This will cause the program to only scan for motifs)\n\nIncluding Enhancers - peak files of enhancer location, peak ID should be gene ID\n-enhancers <peak file> <genome verion>\n  (enhancers to include in search space, peaks/sequences should be named with a gene ID\n  If multiple enhancers per gene, use the same gene ID, and all will be included)\n-enhancersOnly (do not include promoter sequence in motif search)\n\nFASTA files: If you prefer to use your own fasta files, place target sequences and \nbackground sequences in two separate FASTA formated files (must have unique identifiers)\nTarget File - use in place of <input list> (i.e. the first argument)\nBackground File - after output directory (with additional options) use the argument:\n  -fastaBg <background fasta file> (This is recommended for fasta based analysis)\nIn place of the promoter set use \"fasta\", or any valid set (this parameter is ignored)\nWhen finding motifs [-find], only the target file with be searched)\n  -chopify (chops up background regions to match size of target regions)\n    i.e. if background is a full genome or all mRNAs\n\nKnown Motif Options/Visualization:\n-mset <vertebrates|insects|worms|plants|yeast|all> (check against motif collects, default: auto)\n-basic (don't check de novo motifs for similarity to known motifs)\n-bits (scale sequence logos by information content, default: doesn't scale)\n-nocheck (don't check for similarity between novo motif motifs and known motifs)\n-mcheck <motif file> (known motifs to check against de novo motifs,\n-noknown (don't search for known motif enrichment, default: -known)\n-mknown <motif file> (known motifs to check for enrichment,\n-nofacts (omit humor)\n-seqlogo (uses weblogo/seqlogo/ghostscript to visualize motifs, default uses SVG)\n\nAdvanced options:\n-b (use binomial distribution to calculate p-values, hypergeometric is default)\n-nogo (don't search for gene ontology enrichment)\n-humanGO (Convert IDs to human for GO analysis)\n-ontology <ont.genes> [ont.genes] ... (custom ontologies for GO analysis)\n-noweight (no CG correction)\n-noredun (Don't remove predetermined redundant promoters/sequences)\n-g (input file is a group file, i.e. 1st column = id, 2nd = 0 or 1 [1=target,0=back])\n-cpg (use CpG% instead of GC% for sequence normalization)\n-rand (randomize labels for target and backgound sequences)\n-maskMotif <motif file 1> [motif file 2] ... (motifs to mask before motif finding)\n-opt <motif file 1> [motif file 2] ... (motifs to optimize/change length)\n-peaks (will produce peak file of promoters to use with findMotifsGenome.pl)\n-nowarn (no warnings)\n-keepFiles (don't delete temporary files)\n-dumpFasta (create target.fa and background.fa files)\n-min <#> (remove sequences shorter than #, default: 0)\n-max <#> (remove sequences longer than #, default: 1e10)\n-reuse (rerun homer using old seq files etc. with new options\n    and ignores input list, organism)\n-fdr <#> (Calculate empirical FDR for de novo discovery #=number of randomizations)\n\nhomer2 specific options:\n-homer2 (use homer2 instead of original homer, default)\n-nlen <#> (length of lower-order oligos to normalize - general sequences, default: 3)\n  -nmax <#> (Max normalization iterations, default: 160)\n  -neutral (weight sequences to neutral frequencies, i.e. 25%, 6.25%, etc.)\n-olen <#> (lower-order oligo normalization for oligo table, use if -nlen isn't working well)\n-p <#> (Number of processors to use, default: 1)\n-e <#> (Maximum expected motif instance per bp in random sequence, default: 0.01)\n-cache <#> (size in MB for statistics cache, default: 500)\n-quickMask (skip full masking after finding motifs, similar to original homer)\n-homer1 (to force the use of the original homer)\n-minlp <#> (stop looking for motifs when seed logp score gets above #, default: -10)\n\nOriginal homer specific options:\n-homer1 (to force the use of the original homer)\n-depth [low|med|high|allnight] (time spent on local optimization default: med)"
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement",
                    "expressionLib": [
                        "var get_output_filename = function() { if (inputs.output_filename) { return inputs.output_filename; } return inputs.unsorted_file.location.split('/').slice(-1)[0]; };"
                    ]
                }
            ],
            "hints": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "biowardrobe2/scidap:v0.0.2"
                }
            ],
            "inputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "string",
                        "inputBinding": {
                            "prefix": "-k"
                        }
                    },
                    "inputBinding": {
                        "position": 1
                    },
                    "doc": "-k, --key=POS1[,POS2]\nstart a key at POS1, end it at POS2 (origin 1)\n",
                    "id": "#linux-sort.cwl/key"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "doc": "Name for generated output file\n",
                    "id": "#linux-sort.cwl/output_filename"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 4
                    },
                    "id": "#linux-sort.cwl/unsorted_file"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#linux-sort.cwl/sorted_file",
                    "outputBinding": {
                        "glob": "$(get_output_filename())"
                    }
                }
            ],
            "stdout": "$(get_output_filename())",
            "baseCommand": [
                "sort"
            ],
            "doc": "Tool sorts data from `unsorted_file` by key\n\n`default_output_filename` function returns file name identical to `unsorted_file`, if `output_filename` is not provided.\n",
            "id": "#linux-sort.cwl",
            "http://schema.org/name": "linux-sort",
            "http://schema.org/downloadUrl": "https://raw.githubusercontent.com/Barski-lab/workflows/master/tools/linux-sort.cwl",
            "http://schema.org/codeRepository": "https://github.com/Barski-lab/workflows",
            "http://schema.org/license": "http://www.apache.org/licenses/LICENSE-2.0",
            "http://schema.org/isPartOf": {
                "class": "http://schema.org/CreativeWork",
                "http://schema.org/name": "Common Workflow Language",
                "http://schema.org/url": "http://commonwl.org/"
            },
            "http://schema.org/creator": [
                {
                    "class": "http://schema.org/Organization",
                    "http://schema.org/legalName": "Cincinnati Children's Hospital Medical Center",
                    "http://schema.org/location": [
                        {
                            "class": "http://schema.org/PostalAddress",
                            "http://schema.org/addressCountry": "USA",
                            "http://schema.org/addressLocality": "Cincinnati",
                            "http://schema.org/addressRegion": "OH",
                            "http://schema.org/postalCode": "45229",
                            "http://schema.org/streetAddress": "3333 Burnet Ave",
                            "http://schema.org/telephone": "+1(513)636-4200"
                        }
                    ],
                    "http://schema.org/logo": "https://www.cincinnatichildrens.org/-/media/cincinnati%20childrens/global%20shared/childrens-logo-new.png",
                    "http://schema.org/department": [
                        {
                            "class": "http://schema.org/Organization",
                            "http://schema.org/legalName": "Allergy and Immunology",
                            "http://schema.org/department": [
                                {
                                    "class": "http://schema.org/Organization",
                                    "http://schema.org/legalName": "Barski Research Lab",
                                    "http://schema.org/member": [
                                        {
                                            "class": "http://schema.org/Person",
                                            "http://schema.org/name": "Andrey Kartashov",
                                            "http://schema.org/email": "mailto:Andrey.Kartashov@cchmc.org",
                                            "http://schema.org/sameAs": [
                                                {
                                                    "id": "#0000-0001-9102-5681"
                                                }
                                            ]
                                        },
                                        {
                                            "class": "http://schema.org/Person",
                                            "http://schema.org/name": "Michael Kotliar",
                                            "http://schema.org/email": "mailto:misha.kotliar@gmail.com",
                                            "http://schema.org/sameAs": [
                                                {
                                                    "$import": "#0000-0002-6486-3898"
                                                }
                                            ]
                                        }
                                    ]
                                }
                            ]
                        }
                    ]
                }
            ]
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "MultipleInputFeatureRequirement"
                }
            ],
            "sd:upstream": {
                "genome_indices": [
                    "genome-indices.cwl"
                ]
            },
            "inputs": [
                {
                    "type": "string",
                    "label": "Experiment short name/Alias",
                    "sd:preview": {
                        "position": 1
                    },
                    "id": "#main/alias"
                },
                {
                    "type": "File",
                    "format": "http://edamontology.org/format_2330",
                    "label": "Chromosome length file",
                    "doc": "Chromosome length file",
                    "sd:upstreamSource": "genome_indices/chrom_length",
                    "id": "#main/chrom_length_file"
                },
                {
                    "type": "File",
                    "format": "http://edamontology.org/format_1929",
                    "label": "Reference genome FASTA file",
                    "doc": "Reference genome FASTA file. Includes all chromosomes in a single file",
                    "sd:upstreamSource": "genome_indices/fasta_output",
                    "id": "#main/genome_fasta_file"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "enum",
                            "symbols": [
                                "#main/motifs_db/vertebrates",
                                "#main/motifs_db/insects",
                                "#main/motifs_db/worms",
                                "#main/motifs_db/plants",
                                "#main/motifs_db/yeast",
                                "#main/motifs_db/all"
                            ]
                        }
                    ],
                    "default": "vertebrates",
                    "label": "Set motifs DB to check against",
                    "doc": "Set motifs DB to check against",
                    "id": "#main/motifs_db"
                },
                {
                    "type": "File",
                    "format": "http://edamontology.org/format_3003",
                    "label": "Regions file. Headerless BED file with minimum [chrom start end] columns. Optionally, CSV",
                    "doc": "Regions of interest. Formatted as headerless BED file with minimum [chrom start end] columns. Optionally, CSV",
                    "id": "#main/regions_file"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": true,
                    "label": "Skip de novo motif enrichment",
                    "doc": "Skip de novo motif enrichment",
                    "sd:layout": {
                        "advanced": true
                    },
                    "id": "#main/skip_denovo"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "label": "Skip known motif enrichment",
                    "doc": "Skip known motif enrichment",
                    "sd:layout": {
                        "advanced": true
                    },
                    "id": "#main/skip_known"
                },
                {
                    "type": [
                        "null",
                        "int"
                    ],
                    "default": 4,
                    "label": "Threads number",
                    "doc": "Number of threads for those steps that support multithreading",
                    "sd:layout": {
                        "advanced": true
                    },
                    "id": "#main/threads"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "default": false,
                    "label": "Use binomial distribution instead of hypergeometric to calculate p-values",
                    "doc": "Use binomial distribution instead of hypergeometric to calculate p-values",
                    "sd:layout": {
                        "advanced": true
                    },
                    "id": "#main/use_binomial"
                }
            ],
            "outputs": [
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "format": "http://edamontology.org/format_2331",
                    "outputSource": "#main/find_motifs/denovo_motifs",
                    "label": "de novo motifs html file",
                    "doc": "de novo motifs html file",
                    "id": "#main/homer_denovo_motifs"
                },
                {
                    "type": "File",
                    "outputSource": "#main/find_motifs/compressed_results_folder",
                    "label": "Compressed file with Homer motifs",
                    "doc": "Homer motifs",
                    "id": "#main/homer_found_motifs"
                },
                {
                    "type": [
                        "null",
                        "File"
                    ],
                    "format": "http://edamontology.org/format_2331",
                    "outputSource": "#main/find_motifs/known_motifs",
                    "label": "Known motifs html file",
                    "doc": "Known motifs html file",
                    "id": "#main/homer_known_motifs"
                },
                {
                    "type": "File",
                    "format": "http://edamontology.org/format_2330",
                    "outputSource": "#main/find_motifs/stderr_log",
                    "label": "Homer stderr log",
                    "doc": "Homer stderr log",
                    "id": "#main/homer_stderr_log"
                },
                {
                    "type": "File",
                    "format": "http://edamontology.org/format_2330",
                    "outputSource": "#main/find_motifs/stdout_log",
                    "label": "Homer stdout log",
                    "doc": "Homer stdout log",
                    "id": "#main/homer_stdout_log"
                }
            ],
            "steps": [
                {
                    "run": "#bedtools-getfasta.cwl",
                    "in": [
                        {
                            "source": "#main/genome_fasta_file",
                            "id": "#main/bedtools_get_fasta_background/genome_fasta_file"
                        },
                        {
                            "source": "#main/bedtools_shuffle/shuffled_bed_file",
                            "id": "#main/bedtools_get_fasta_background/intervals_file"
                        }
                    ],
                    "out": [
                        "#main/bedtools_get_fasta_background/sequences_file"
                    ],
                    "id": "#main/bedtools_get_fasta_background"
                },
                {
                    "run": "#bedtools-getfasta.cwl",
                    "in": [
                        {
                            "source": "#main/genome_fasta_file",
                            "id": "#main/bedtools_get_fasta_target/genome_fasta_file"
                        },
                        {
                            "source": "#main/make_unique/output_file",
                            "id": "#main/bedtools_get_fasta_target/intervals_file"
                        }
                    ],
                    "out": [
                        "#main/bedtools_get_fasta_target/sequences_file"
                    ],
                    "id": "#main/bedtools_get_fasta_target"
                },
                {
                    "run": "#bedtools-merge.cwl",
                    "in": [
                        {
                            "source": "#main/bedtools_sort/sorted_file",
                            "id": "#main/bedtools_merge/bed_file"
                        }
                    ],
                    "out": [
                        "#main/bedtools_merge/merged_bed_file"
                    ],
                    "id": "#main/bedtools_merge"
                },
                {
                    "run": "#bedtools-shuffle.cwl",
                    "in": [
                        {
                            "source": "#main/make_unique/output_file",
                            "id": "#main/bedtools_shuffle/bed_file"
                        },
                        {
                            "source": "#main/chrom_length_file",
                            "id": "#main/bedtools_shuffle/chrom_length_file"
                        },
                        {
                            "source": "#main/bedtools_subtract/difference_bed_file",
                            "id": "#main/bedtools_shuffle/incl_bed_file"
                        },
                        {
                            "default": 10000,
                            "id": "#main/bedtools_shuffle/max_tries"
                        },
                        {
                            "default": true,
                            "id": "#main/bedtools_shuffle/no_overlapping"
                        },
                        {
                            "default": 123456789,
                            "id": "#main/bedtools_shuffle/seed"
                        }
                    ],
                    "out": [
                        "#main/bedtools_shuffle/shuffled_bed_file"
                    ],
                    "id": "#main/bedtools_shuffle"
                },
                {
                    "run": "#bedtools-slop.cwl",
                    "in": [
                        {
                            "source": "#main/make_unique/output_file",
                            "id": "#main/bedtools_slop/bed_file"
                        },
                        {
                            "default": 20000,
                            "id": "#main/bedtools_slop/bi_direction"
                        },
                        {
                            "source": "#main/chrom_length_file",
                            "id": "#main/bedtools_slop/chrom_length_file"
                        }
                    ],
                    "out": [
                        "#main/bedtools_slop/extended_bed_file"
                    ],
                    "id": "#main/bedtools_slop"
                },
                {
                    "run": "#linux-sort.cwl",
                    "in": [
                        {
                            "default": [
                                "1,1",
                                "2,2n"
                            ],
                            "id": "#main/bedtools_sort/key"
                        },
                        {
                            "source": "#main/bedtools_slop/extended_bed_file",
                            "id": "#main/bedtools_sort/unsorted_file"
                        }
                    ],
                    "out": [
                        "#main/bedtools_sort/sorted_file"
                    ],
                    "id": "#main/bedtools_sort"
                },
                {
                    "run": "#bedtools-subtract.cwl",
                    "in": [
                        {
                            "source": "#main/bedtools_merge/merged_bed_file",
                            "id": "#main/bedtools_subtract/reduced_bed_file"
                        },
                        {
                            "source": "#main/make_unique/output_file",
                            "id": "#main/bedtools_subtract/subtracted_bed_file"
                        }
                    ],
                    "out": [
                        "#main/bedtools_subtract/difference_bed_file"
                    ],
                    "id": "#main/bedtools_subtract"
                },
                {
                    "run": "#homer-find-motifs.cwl",
                    "in": [
                        {
                            "source": "#main/bedtools_get_fasta_background/sequences_file",
                            "id": "#main/find_motifs/background_fasta_file"
                        },
                        {
                            "source": "#main/motifs_db",
                            "id": "#main/find_motifs/motifs_db"
                        },
                        {
                            "source": "#main/skip_denovo",
                            "id": "#main/find_motifs/skip_denovo"
                        },
                        {
                            "source": "#main/skip_known",
                            "id": "#main/find_motifs/skip_known"
                        },
                        {
                            "source": "#main/bedtools_get_fasta_target/sequences_file",
                            "id": "#main/find_motifs/target_fasta_file"
                        },
                        {
                            "source": "#main/threads",
                            "id": "#main/find_motifs/threads"
                        },
                        {
                            "source": "#main/use_binomial",
                            "id": "#main/find_motifs/use_binomial"
                        }
                    ],
                    "out": [
                        "#main/find_motifs/compressed_results_folder",
                        "#main/find_motifs/known_motifs",
                        "#main/find_motifs/denovo_motifs",
                        "#main/find_motifs/stdout_log",
                        "#main/find_motifs/stderr_log"
                    ],
                    "id": "#main/find_motifs"
                },
                {
                    "run": "#custom-bash.cwl",
                    "in": [
                        {
                            "source": "#main/regions_file",
                            "id": "#main/make_unique/input_file"
                        },
                        {
                            "default": "cat \"$0\" | tr -d '\\r' | tr \",\" \"\\t\" | cut -f 1-3 | awk NF | sort -u -k1,1 -k2,2n -k3,3n > `basename $0`\n",
                            "id": "#main/make_unique/script"
                        }
                    ],
                    "out": [
                        "#main/make_unique/output_file"
                    ],
                    "id": "#main/make_unique"
                }
            ],
            "label": "Motif Finding with HOMER with random background regions",
            "doc": "Motif Finding with HOMER with random background regions\n---------------------------------------------------\n\nHOMER contains a novel motif discovery algorithm that was designed for regulatory element analysis\nin genomics applications (DNA only, no protein). It is a differential motif discovery algorithm,\nwhich means that it takes two sets of sequences and tries to identify the regulatory elements that\nare specifically enriched in on set relative to the other. It uses ZOOPS scoring (zero or one\noccurrence per sequence) coupled with the hypergeometric enrichment calculations (or binomial) to\ndetermine motif enrichment. HOMER also tries its best to account for sequenced bias in the dataset.\nIt was designed with ChIP-Seq and promoter analysis in mind, but can be applied to pretty much any\nnucleic acids motif finding problem.\n\nHere is how we generate background for Motifs Analysis\n-------------------------------------\n1. Take input file with regions in a form of \u201cchr\" \u201cstart\" \u201cend\"\n2. Sort and remove duplicates from this regions file\n3. Extend each region in 20Kb into both directions\n4. Merge all overlapped extended regions\n5. Subtract not extended regions from the extended ones\n6. Randomly distribute not extended regions within the regions\n   that we got as a result of the previous step\n7. Get fasta file from these randomly distributed regions (from the previous step). Use it as background\n\nFor more information please refer to:\n-------------------------------------\n[Official documentation](http://homer.ucsd.edu/homer/motif/)",
            "id": "#main",
            "http://schema.org/name": "Motif Finding with HOMER with random background regions",
            "http://schema.org/alternateName": "Motif Finding with HOMER with random background regions",
            "http://schema.org/downloadUrl": "https://raw.githubusercontent.com/datirium/workflows/master/workflows/homer-motif-analysis.cwl",
            "http://schema.org/codeRepository": "https://github.com/datirium/workflows",
            "http://schema.org/license": "http://www.apache.org/licenses/LICENSE-2.0",
            "http://schema.org/isPartOf": {
                "class": "http://schema.org/CreativeWork",
                "http://schema.org/name": "Common Workflow Language",
                "http://schema.org/url": "http://commonwl.org/"
            },
            "http://schema.org/creator": [
                {
                    "class": "http://schema.org/Organization",
                    "http://schema.org/legalName": "Cincinnati Children's Hospital Medical Center",
                    "http://schema.org/location": [
                        {
                            "class": "http://schema.org/PostalAddress",
                            "http://schema.org/addressCountry": "USA",
                            "http://schema.org/addressLocality": "Cincinnati",
                            "http://schema.org/addressRegion": "OH",
                            "http://schema.org/postalCode": "45229",
                            "http://schema.org/streetAddress": "3333 Burnet Ave",
                            "http://schema.org/telephone": "+1(513)636-4200"
                        }
                    ],
                    "http://schema.org/logo": "https://www.cincinnatichildrens.org/-/media/cincinnati%20childrens/global%20shared/childrens-logo-new.png",
                    "http://schema.org/department": [
                        {
                            "class": "http://schema.org/Organization",
                            "http://schema.org/legalName": "Allergy and Immunology",
                            "http://schema.org/department": [
                                {
                                    "class": "http://schema.org/Organization",
                                    "http://schema.org/legalName": "Barski Research Lab",
                                    "http://schema.org/member": [
                                        {
                                            "class": "http://schema.org/Person",
                                            "http://schema.org/name": "Michael Kotliar",
                                            "http://schema.org/email": "mailto:michael.kotliar@cchmc.org",
                                            "http://schema.org/sameAs": [
                                                {
                                                    "$import": "#0000-0002-6486-3898"
                                                }
                                            ]
                                        }
                                    ]
                                }
                            ]
                        }
                    ]
                }
            ]
        }
    ],
    "cwlVersion": "v1.0",
    "$schemas": [
        "http://schema.org/version/9.0/schemaorg-current-http.rdf"
    ],
    "$namespaces": {
        "s": "http://schema.org/"
    }
}
